/****************************************************************************
*                                                                           *
*                   Color Selector by A.P.Mazur Jun 15,1989                 *
*                   APM Labs                                                *
*                   511 Dix Way                                             *
*                   San Jose, CA 95125                                      *
*                   All rights reserved. Copyright 1989-1990.               *
*                                                                           *
*  This module allows the caller to select a color.                         *
*  SelectColor() function accepts three parameters:                         *
*   hParent      : handle to the window                                     *
*                  When dialog is finished hParent is activated.            *
*   pColor       : pointer to the LONG variable. If the dialog terminates   *
*                  with an OK message pColor variable will be set to the    *
*                  selected color value, otherwise the pColor remains       *
*                  unchanged.                                               *
*   applyMessage : a message to be sent to the parent window in order to    *
*                  notify about font change. If set to 0 no notification    *                                                                           *
*                  takes place, otherwise a message :                       *
*                    Send(hParent,WM_COMMAND,applyMessage,0L);              *
*                  will be executed each time user changes a color.         *
*                  Sending notification disables a Cancel button.           * 
*  SelectColor returns one of following codes:                              *
*                                                                           *
*    -1      : Insufficient memory to create the dialog box.                *
*     1      : A new color was accepted by the user. The pColor variable    *
*              is updated.                                                  *
*     2      : The dialog was  canceled by the user. The pColor variable    *
*              remains unchanged.                                           *
*     3      : The Color Selector was "busy". Since a Color Selector is NOT *
*              reentrant it can't be used simultaneously with two windows.  *
*              A second invocation will display a message box with the      *
*              information on which application is using a Color Selector,  *
*              when dissmised it will return 3.                             *
*                                                                           *
****************************************************************************/
             /* imports from colorsel.c module */

extern int  FAR PASCAL SelectColor(HWND  hParent,LONG FAR *pColor,WORD applyMessage); 
