/* fdparm.c: Shows contents of floppy disk's boot sector */

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include <malloc.h>
#include "bootsec.h"

main()
{
char    disk, letter;
BOOTSEC *boot, *bootsec (int);

	printf ("\nWhich disk do you want to see? ");
	letter = getche();
	disk = toupper (letter)-'A';
	if ((boot = bootsec (disk)) != NULL) {
		printf ("\n\nBoot sector for drive %c:\n", toupper (letter));
		printf ("\n%05X  Signature ", (unsigned char) boot->signature);
		printf ("\n%5d  Byte per sector ", boot->byPerSec);
		printf ("\n%5d  Sectors per cluster ", boot->secPerClus);
		printf ("\n%5d  Number of reserved sectors ", boot->resSecs);
		printf ("\n%5d  Number of FATs ", boot->nFats);
		printf ("\n%5d  Number of root entries ", boot->nRootEnts);
		printf ("\n%5u  Total number of sectors ", boot->totSec);
		printf ("\n%05X  Media descriptor ", (unsigned char) boot->mediaDescr);
		printf ("\n%5d  Sector per FAT ", boot->secPerFat);
		printf ("\n%5d  Sector per track ", boot->secPerTrack);
		printf ("\n%5d  Number of drive heads ", boot->nHeads);
		printf ("\n%5u  Number of hidden sectors ", boot->nHidden);
	} else
		printf ("\nError reading drive %c", disk + 'A');

	if (boot)
		free (boot);
}

BOOTSEC *bootsec (int drive)
/* Use BIOS Int 13h, fcn 02h to read boot sector */
{
union REGS  reg;
struct SREGS sreg;
BOOTSEC *buf;

	if ((buf = malloc (sizeof *buf)) != NULL) {
		reg.h.ah = 2;           /* Int 13h, fcn 2 */
		reg.h.al = 1;           /* one sector */
		reg.h.ch = 0;           /* track zero */
		reg.h.cl = 1;           /* physical sector 1 */
		reg.h.dh = 0;           /* head zero */
		reg.h.dl = drive;       /* floppy drive */
		reg.x.bx = FP_OFF (buf);    /* buffer offset */
		sreg.es  = FP_SEG (buf);    /* and segment */
		int86x (0x13, &reg, &reg, &sreg);
		if (reg.x.cflag != 0) {         /* if failed */
			free (buf);
			buf = NULL;
		}
	}
	return (buf);
}




