/* hardware.c: Shows the system hardware configuration */

#include <stdio.h>
#include <dos.h>
#include <graph.h>
#include "biosarea.h"
#include "mk_fp.h"

main()
{
    unsigned n, far *ega = MK_FP (0x0040, 0x0087);
    unsigned char far *machineID = MK_FP (0xF000, 0xFFFE);
    BIOSDATA far *bios = MK_FP (0x0000, 0x0400);

        _clearscreen (0);
    puts ("SYSTEM HARDWARE CONFIGURATION");

    printf ("\nMachine type     %02X ", *machineID);
    switch (*machineID) {
        case 0xFF: puts (" (PC)"); break;
        case 0xFE: puts (" (PC/XT)"); break;
        case 0xFD: puts (" (PCjr)"); break;
        case 0xFC: puts (" (PC/AT)"); break;
        case 0xF9: puts (" (PC Convertible)"); break;
        default: puts (" (Unknown)");
    }

    printf ("\nMain memory size in K    %u\n\n", bios->mainMem);

    puts ("Disk drives:");
    if (!bios->eqptFlags.hasFloppies)
        n = 0;
    else
        n = bios->eqptFlags.nDisks + 1;
    printf (" Number of diskette drives     %u\n", n);
    printf (" Hard disk installed           %u\n\n",
            (bios->hardDiskStat == 0L) ? "No" : "Yes");
    puts ("Display:");
    printf ("  Initial video mode       %u",bios->eqptFlags.initVideo);
    switch (bios->eqptFlags.initVideo) {
        case 0: puts (" (Undefined)"); break;
        case 1: puts (" (80 x 25 color)"); break;
        case 2: puts (" (40 x 25 color)"); break;
        case 3: puts (" (80 x 25 monochrome)"); break;
    }
    printf (" Current video mode        %u",bios->videoMode);
    switch (bios->videoMode) {
        case 0: puts (" (40 x 25 B&W text, color adapter)"); break;
        case 1: puts (" (40 x 25 color text, color adapter)"); break;
        case 2: puts (" (80 x 25 B&W text, color adapter)"); break;
        case 3: puts (" (80 x 25 color text, color adapter)"); break;
        case 7: if (*ega != 0)
                    puts (" (EGA 80 x 25 B&W text)");
                else
                    puts (" (Monochrome 80 x 25 text)");
                break;
        default: puts (" (Graphics mode)");
    }
    printf (" Video buffer size in bytes        %u\n",bios->vidBuffSz);
    printf (" Active display page               %u\n",bios->activeDispPage);
    printf (" Video adapter port address        %04Xh\n",bios->activeDispPort);
    printf (" Adapter type                      ");
    if (*ega != 0)
        puts ("EGA");
    else
        if ((bios->videoMode == 7) && (bios->vidBuffSz > 4096))
            puts ("Hercules");
        else
            if(bios->videoMode == 7)
                puts ("Monochrome");
            else
                if (bios->videoMode == 3)
                    puts ("CGA");
                else
                    if (bios->videoMode == 2)
                        puts ("Compaq");
                    else puts ("Unknown");

    puts ("\nPorts:");
    printf(" Number of serial ports     %u\n",bios->eqptFlags.nSerialPorts);
    printf(" Number of parallel ports   %u\n",bios->eqptFlags.nLPT);
    printf(" Game port attached         %s\n",
                        (bios->eqptFlags.gamePort) ? "Yes" : "No");
}





