/* popup.h: Prototype and typedef for popup.c library */

typedef struct {
	int top, left, bottom, right,       /* border location */
	style,                              /* border style */
	normal, hilite,                     /* test attributes */
	normback, hiback;
char *text;                             /* fixed text contents */
int lastrow, lastcol;                   /* last cursor position */
} POPUP;

typedef struct {
	int row,                            /* row where bar appears */
		interval,                       /* cols between first chars */
		fore, back;                     /* foreground/background colors */
	char *choice;                       /* pointer to text contents */
} MENUBAR;

void popShow (POPUP *pop);              /* display popup window */

void popKeep (POPUP *win);              /* save window state */

void popUse (POPUP *win);               /* re-enable a window */

void popCenter (POPUP *win, int row, char *string);
										/*Center string in window */

void popRewrite (POPUP *win, int row, int fgcolor, int bgcolor);
								/* Rewrite pop-up row in new colors */

void popHilite (POPUP *win, int row);   /* Hilight text in popup row */

void menubar (MENUBAR *spec);   /* Write the menu bar described by spec */


