/* textscrn.h:  Stretching text screen operation for QC 2.0 */

/* Text color constants */
#define BLACK       0
#define BLUE        1
#define GREEN       2
#define CYAN        3
#define RED         4
#define MAGENTA     5
#define BROWN       6
#define LTGRAY      7
#define DKGRAY      8
#define LTBLUE      9
#define LTGREEN     10
#define LTCYAN      11
#define LTRED       12
#define LTMAGENTA   13
#define YELLOW      14
#define WHITE       15
#define BLINK       0x80        /* OR with textcolor for blinking */

/* Added control functions */
void _cleareol (void);          /* clear to end of line */
void _outtextf (char*, ...);    /* formatted _outtext */
void _outch (char);             /* single-char output */
void _textbox (int top, int left, int bottom,   /* draw test box */
                int right, int style);
void _savescrn (int page);      /* save screen image in page */
void _restscrn (int page);      /* restore saved screen to page */
void _setbordwindow (int top, int left,     /* bordered window */
                        int bottom, int right,
                        int borderstyle, int fgcolor, int bgcolor);

/* Inquiry functions */
int maxcol (void);          /* max column on display     */
int maxrow (void);          /* max row on display        */
int maxpage (void);         /* highest avail video page  */
int activepage (void);      /* currently active page     */
int visualpage (void);      /* currently visible page    */
int wherex (void);          /* cursor col in active page */
int wherey (void);          /* cursor row in active page */


